#!/usr/bin/python3
import os
import sys
import subprocess
from subprocess import check_output, run
import time
from time import sleep
import datetime
from datetime import datetime


def get_time():
    ts1 = str(datetime.now()).split('.')[0]
    return ts1


def call_vm_shutdown(vmid):
        run(['/usr/sbin/qm','shutdown',vmid])

def call_lxc_shutdown(lxc):
        run(['/usr/bin/lxc-stop',lxc])

def get_status(vmid):
    vmstatus = check_output(['/usr/sbin/qm','shutdown',vmid])
    vmstatus = vmstatus.decode().split(': ')[1].rstrip()
    return vmstatus


def monitor_status(vmid):
        vmstatus = 'running'
        while vmstatus == 'running':
            sleep(5)
            vmstatus = check_output(['/usr/sbin/qm','status',vmid])
            vmstatus = vmstatus.decode().split(': ')[1].rstrip()
        return 'Done'

def lxc_status(lxc):
        vmstatus = 'running'
        while vmstatus.lower() == 'running':
            sleep(5)
            vmoutput = check_output(['lxc-info', lxc])
            if b'RUNNING' not in vmoutput:
                vmstatus = 'stopped'
            #vmstatus = vmstatus.decode().split(': ')[1].rstrip()
            print(vmstatus)
        return 'Done'

def shutdown_host():
        run(['/usr/sbin/init','0'])

def main():
    timestamp = get_time()
    print(f'Start time: {timestamp}')
    vms = ['115', '109', '108', '107', '101']
    for vm in vms:
        try:
            print(f'Shutting down {vm}')
            call_vm_shutdown(vm)
            vresult = monitor_status(vm)
            print(f'{vresult}')
        except Exception as e:
            print(f'{vm} currently not running')
    lxcs = ['110', '114', '113', '111', '103', '104', '105', '112']
    for lxc in lxcs:
        try:
            print(f'Shutting down {lxc}')
            call_lxc_shutdown(lxc)
            vresult = lxc_status(lxc)
            print(f'{vresult}')
        except Exception as e:
            print(f'{lxc} currently not running')
    timestamp = get_time()
    print(f'End time: {timestamp}')
    #shutdown_host()

if __name__ == '__main__':
    main()
